# $Revision: 1.43.2.1 $, $Date: 2006/11/06 22:15:31 $
%include	/usr/lib/rpm/macros.perl
Summary:	Visual (www) interface to explore a CVS repository
Summary(pl):	Wizualny (WWW) interfejs do przegldania repozytorium CVS
Name:		cvsweb
Version:	3.0.6
Release:	3
Epoch:		1
License:	BSD
Group:		Development/Tools
Source0:	http://people.FreeBSD.org/~scop/cvsweb/%{name}-%{version}.tar.gz
# Source0-md5:	0e1eec962b1db00e01b295fff84b6e89
Source1:	%{name}-apache.conf
URL:		http://www.freebsd.org/projects/cvsweb.html
Patch0:		%{name}-config.patch
Patch1:		%{name}-emptyscript.patch
BuildRequires:	rpmbuild(macros) >= 1.268
# for %{_prefix}/lib/cgi-bin
Requires:	filesystem >= 2.0-1
Requires:	rcs
# for /etc/mime.types
Requires:	mailcap
Requires:	webapps
Conflicts:	apache-base < 2.2.0-8
Conflicts:	apache1 < 1.3.34-6
BuildArch:	noarch
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		_webapps	/etc/webapps
%define		_webapp		%{name}
%define		_sysconfdir	%{_webapps}/%{_webapp}
%define		_appdir		%{_datadir}/%{name}
%define		_cgibindir	%{_prefix}/lib/cgi-bin
%define		_enscriptdir	%{_datadir}/enscript/hl

%description
CVSweb is a WWW interface for CVS repositories with which you can
browse a file hierarchy on your browser to view each file's revision
history in a very handy manner. CVSweb was originally written by Bill
Fenner for the FreeBSD Project. FreeBSD-CVSweb, formerly known as
knu-CVSweb, is an enhanced version of CVSweb based on Henner Zeller's
CVSweb, which is an extended version of the original CVSweb. This
version contains numerous cleanups, bug-fixes, security enhancements
and feature improvements.

%description -l pl
CVSweb jest interfejsem WWW dla repozytoriw CVS dziki ktremu mona
przeglda ich zawarto w przegldarce WWW widzc pen histori
zmian i numerw rewizji dla kadego z plikw. CVSWeb zosta stworzony
przez Billa Fennera dla projektu FreeBSD. FreeBSD-CVSweb dawniej znany
jako knu-CVSweb jest rozszerzon wersj opart na wersji Hennera
Zellera, ktra z kolei bya oparta na oryginalnej wersji. Kod obecnej
wersji zosta uporzdkowany i oczyszczony, usunitych zostao rwnie
wiele bdw. Wprowadzono take duo poprawek bezpieczestwa oraz
rozbudowano funkcjonalno.

%package -n enscript-%{name}
Summary:	Enscript language files for CVSweb
Summary(pl):	Pliki jzyka Enscript dla CVSweba
Group:		Applications/Publishing
Requires:	enscript >= 1.6.4-1.2

%description -n enscript-%{name}
Enscript language files for CVSweb.

%description -n enscript-%{name} -l pl
Pliki jzyka Enscript dla CVSweba.

%prep
%setup -q
%patch0 -p1
%patch1 -p1

cp -a cvsweb.conf* samples

# remove backups
find '(' -name '*~' -o -name '*.orig' ')' | xargs -r rm -v

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{%{_appdir}/{css,icons},%{_cgibindir},%{_enscriptdir},%{_sysconfdir}}

install %{name}.cgi	$RPM_BUILD_ROOT%{_cgibindir}
install css/*		$RPM_BUILD_ROOT%{_appdir}/css
install enscript/*	$RPM_BUILD_ROOT%{_enscriptdir}
install icons/*		$RPM_BUILD_ROOT%{_appdir}/icons

install %{name}.conf	$RPM_BUILD_ROOT%{_sysconfdir}
echo '# vim:syn=perl' >> $RPM_BUILD_ROOT%{_sysconfdir}/%{name}.conf
install %{SOURCE1} $RPM_BUILD_ROOT%{_sysconfdir}/apache.conf
install %{SOURCE1} $RPM_BUILD_ROOT%{_sysconfdir}/httpd.conf

%clean
rm -rf $RPM_BUILD_ROOT

%post
if [ "$1" = 1 ]; then
%banner %{name} -e <<'EOF'
You might want to install optionally 'cvsgraph' program.
EOF
fi

%triggerin -- apache1 < 1.3.37-3, apache1-base
%webapp_register apache %{_webapp}

%triggerun -- apache1 < 1.3.37-3, apache1-base
%webapp_unregister apache %{_webapp}

%triggerin -- apache < 2.2.0, apache-base
%webapp_register httpd %{_webapp}

%triggerun -- apache < 2.2.0, apache-base
%webapp_unregister httpd %{_webapp}

%triggerpostun -- %{name} < 1:3.0.6-0.2
# rescue app config
if [ -f /etc/%{name}/cvsweb.conf.rpmsave ]; then
	mv -f %{_sysconfdir}/cvsweb.conf{,.rpmnew}
	mv -f /etc/%{name}/cvsweb.conf.rpmsave %{_sysconfdir}/cvsweb.conf
fi

# migrate from old config location (only apache2, as there was no apache1 support)
if [ -f /etc/httpd/%{name}.conf.rpmsave ]; then
	cp -f %{_sysconfdir}/httpd.conf{,.rpmnew}
	mv -f /etc/httpd/%{name}.conf.rpmsave %{_sysconfdir}/httpd.conf
	httpd_reload=1
fi

# migrate from apache-config macros
if [ -f /etc/%{name}/apache.conf.rpmsave ]; then
	if [ -d /etc/apache/webapps.d ]; then
		cp -f %{_sysconfdir}/apache.conf{,.rpmnew}
		cp -f /etc/%{name}/apache.conf.rpmsave %{_sysconfdir}/apache.conf
	fi

	if [ -d /etc/httpd/webapps.d ]; then
		cp -f %{_sysconfdir}/httpd.conf{,.rpmnew}
		cp -f /etc/%{name}/apache.conf.rpmsave %{_sysconfdir}/httpd.conf
	fi
	rm -f /etc/%{name}/apache.conf.rpmsave
fi

if [ -L /etc/apache/conf.d/09_%{name}.conf ]; then
	rm -f /etc/apache/conf.d/09_%{name}.conf
	apache_reload=1
fi
if [ -L /etc/apache/conf.d/79_%{name}.conf ]; then
	rm -f /etc/apache/conf.d/79_%{name}.conf
	apache_reload=1
fi
if [ -L /etc/httpd/httpd.conf/09_%{name}.conf ]; then
	rm -f /etc/httpd/httpd.conf/09_%{name}.conf
	httpd_reload=1
fi

if [ "$apache_reload" ]; then
	/usr/sbin/webapp register apache %{_webapp}
	%service -q apache reload
fi
if [ "$httpd_reload" ]; then
	/usr/sbin/webapp register httpd %{_webapp}
	%service -q httpd reload
fi

%files
%defattr(644,root,root,755)
%doc ChangeLog INSTALL NEWS README TODO samples
%dir %attr(750,root,http) %{_sysconfdir}
%config(noreplace) %verify(not md5 mtime size) %attr(640,root,http) %{_sysconfdir}/%{name}.conf
%config(noreplace) %verify(not md5 mtime size) %attr(640,root,root) %{_sysconfdir}/apache.conf
%config(noreplace) %verify(not md5 mtime size) %attr(640,root,root) %{_sysconfdir}/httpd.conf
%attr(755,root,root) %{_cgibindir}/cvsweb.cgi
%{_appdir}

%files -n enscript-%{name}
%defattr(644,root,root,755)
%{_enscriptdir}/*

%define date	%(echo `LC_ALL="C" date +"%a %b %d %Y"`)
%changelog
* %{date} PLD Team <feedback@pld-linux.org>
All persons listed below can be reached at <cvs_login>@pld-linux.org

$Log: cvsweb.spec,v $
Revision 1.43.2.1  2006/11/06 22:15:31  glen
- AC-branch due filesystem version mismatch

Revision 1.43  2006/10/27 18:26:56  qboosh
- updated dep for /usr/lib/cgi-bin dir (FHS -> filesystem); release 3

Revision 1.42  2006/09/30 15:05:21  glen
- rel 2

Revision 1.41  2006/09/29 21:25:58  glen
- update webapp triggers due apache1 package split

Revision 1.40  2006/02/02 15:14:49  glen
- update apache2 trigger to match apache-base in case somebody decides not to
  use apache2.2 virtual pkg (freedom of choice one of the pld mottos)

Revision 1.39  2006/01/24 14:14:32  glen
- rel 1; STBR

Revision 1.38  2006/01/24 12:38:41  qboosh
- pl for enscript-

Revision 1.37  2006/01/12 09:27:41  glen
- require enscript with patched php hiliting

Revision 1.36  2006/01/10 23:31:39  glen
- enscript files need to be in enscript dir for $allow_enscript to work, so created enscript-cvsweb subpackage

Revision 1.35  2006/01/09 23:53:05  glen
- list incompatible apaches
- add webapp triggers

Revision 1.34  2006/01/09 23:42:29  glen
- merged /usr/lib/cgi-bin changes from DEVEL

Revision 1.33  2006/01/09 23:33:05  glen
- apache config moved to SOURCES
- add patch to allow cvsweb.cgi being used as handler for whole vhost
- use webapps framework

Revision 1.32  2006/01/09 22:00:54  glen
- 3.0.6

Revision 1.31  2005/06/19 19:35:49  glen
- FHS fix: cvsweb.cgi moved to %{_datadir}

Revision 1.30  2005/06/19 19:28:58  glen
- playing with the config slots

Revision 1.29  2005/06/18 17:12:47  qboosh
- typo, unified CVS caps

Revision 1.28  2005/06/18 15:17:55  glen
- merged 3.0.5 from DEVEL

Revision 1.21.2.10  2005/06/18 15:11:36  glen
- optional cvsgraph

Revision 1.21.2.9  2005/06/18 14:58:58  glen
- added possible mod_perl configuration

Revision 1.21.2.8  2005/06/18 14:36:57  glen
- configs moved to /etc/cvsweb
- apache configs are triggered

Revision 1.21.2.7  2005/06/18 12:52:34  glen
- changelog truncated to 3.0.1 -- it's different sources

Revision 1.21.2.6  2005/06/18 12:12:27  glen
- unpackage backup files

Revision 1.21.2.5  2005/01/29 15:46:06  hawk
- updated to 3.0.5, release 0.1
- included macros.perl for perl autodeps, removed unecessary R's
- rewritten descriptions, based on description from CVSweb home page

Revision 1.21.2.4  2004/11/23 06:39:50  twittner
- upgrade to 3.0.4 , rel. 0.1
- moved cvsweb.cgi to %{_libdir}/cvsweb.cgi
  cvsweb.cgi in new location and other cgi programs located
  in /home/services/httpd/cgi-bin should work after upgrade
  with the same URL but only with apache-2.x.xx current
  configuration layout.
- restart working webserver(s) during upgrade (not only
  apache).

Revision 1.21.2.3  2004/09/18 22:12:55  twittner
- 3.0.2

Revision 1.21.2.2  2004/08/18 23:23:06  ankry
- spaces -> tabs

Revision 1.21.2.1  2004/08/18 23:09:37  twittner
- 3.0.1
